import { DatabaseObject } from 'database-builder';
import { Observable, Observer } from 'rxjs';
export declare abstract class DatabaseMigrationBase {
    version(database: DatabaseObject, version: number): Observable<boolean>;
    protected error(error: string, observer: Observer<any>): void;
    protected abstract migrationExecute(database: DatabaseObject, control: {
        oldVersion: number;
        newVersion: number;
    }): Observable<boolean>;
    private checkTableVersion;
    private checkVersion;
    private getVersion;
    private migration;
}
